      *********************************************************************
      * MODULE NAME:       FAAEXP01.CBL                                   *
      *                    modified by Marta Wojnar, IBM Germany          *
      * FUNCTION:        - get server name from the shared memory         *
      *                  - rename V123/V124 to XXV3/XXV4 and              *
      *                    C0nn to XXnn, where XX are the first two chars *
      *                    of the server terminal-id in host CICS         *
      * STATUS:                                                           *
      *  24 July 1995     Version 3 Release 0                             *
      *                                                                   *
      *********************************************************************
       IDENTIFICATION DIVISION.
       PROGRAM-ID. FAAEXP01.
       ENVIRONMENT DIVISION.
       DATA DIVISION.
      *
       WORKING-STORAGE SECTION.
       77 WNAME                              PIC X(2) VALUE 'XX'.
       01 WS-GETNMEMF PIC X(4)  VALUE X'07000000'.
       01 WS-GETNMEMR REDEFINES WS-GETNMEMF PIC 9(8) COMP-5.
       01 WS-MEMADDR  POINTER.
       01 WS-RETCODE  PIC 9(8)  COMP-5.
       01 WS-MEMNAME.
          02 FILLER   PIC X(15)         VALUE '\SHAREMEM\MWVDV'.
          02 FILLER   PIC X             VALUE X'00'.
      *
       LINKAGE SECTION.
       COPY FAAEXW01.
       01 EXIT-01-TERMINAL-NAME                           PIC X(4).
       01  SHRMEM.
           02 SCNAME                PIC X(4).
      *
       PROCEDURE DIVISION USING EXIT-01-BLOCK.
      *
       B1-BEGIN SECTION.
      *
           IF WNAME = 'XX'
              CALL 'DosGetNamedSharedMem' USING
                   BY REFERENCE WS-MEMADDR
                   BY REFERENCE WS-MEMNAME
                   BY VALUE     WS-GETNMEMR
                   RETURNING    WS-RETCODE
              END-CALL
              IF WS-RETCODE NOT = 0
                 GO TO B1-EXIT
              END-IF
              SET ADDRESS OF SHRMEM TO WS-MEMADDR
              MOVE SCNAME TO WNAME
           END-IF
      *
           SET  ADDRESS OF EXIT-01-TERMINAL-NAME
             TO EXIT-01-TERMINAL-NAME-POINTER
           IF EXIT-01-CHANGE-NAME-OUTBOUND
      *       - Change the first two bytes to connection name,
      *         for V123 and V124 change third byte to V
              IF EXIT-01-TERMINAL-NAME(1:2) = 'V1'
                 MOVE 'V' TO EXIT-01-TERMINAL-NAME(3:1)
              END-IF
              MOVE WNAME TO EXIT-01-TERMINAL-NAME(1:2)
           ELSE
      *
      *        - Change the name back
               IF EXIT-01-TERMINAL-NAME(1:2) = WNAME
                  IF EXIT-01-TERMINAL-NAME(3:1) = 'V'
                     MOVE 'V12' TO EXIT-01-TERMINAL-NAME(1:3)
                  ELSE
                     MOVE 'C0' TO EXIT-01-TERMINAL-NAME(1:2)
                  END-IF
               END-IF
           END-IF
           .
       B1-EXIT. GOBACK.
